package rocks.zipcode.io.quiz4.collections;

import java.util.*;

/**
 * @author leon on 11/12/2018.
 */
public class ComparableTreeSet<T> extends TreeSet<T> implements Comparable<ComparableTreeSet<T>>{

    public ComparableTreeSet(T... arr) {
        this.addAll(Arrays.asList(arr));
    }

    public ComparableTreeSet() {
    }

    @Override
    public int compareTo(ComparableTreeSet<T> o) {
        try {
            return (this.first().toString().compareTo(o.first().toString()));
        }catch (NoSuchElementException e) {
            return 0;
        }
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        ArrayList<T> arrayList = new ArrayList<>();
        arrayList.addAll(this);
        for (int i = 0; i < this.size(); i++) {
            sb.append(arrayList.get(i));
            if (i != this.size()-1) {
                sb.append(", ");
            }
        }
        return "[" + sb.toString() + "]";
    }
}
