package rocks.zipcode.io.quiz4.collections;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.NoSuchElementException;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.function.Consumer;

/**
 * @author leon on 11/12/2018.
 */
public class SimpleStringGroup implements Iterable<String> {
    ArrayList<String> strings = new ArrayList<>();

    public SimpleStringGroup() {
    }

    public Integer count() {
        return strings.size();
    }

    public void insert(String string) {
        strings.add(string);
    }

    public Boolean has(String valueToInsert) {
        return strings.contains(valueToInsert);
    }

    public String fetch(int indexOfValue) {
        return strings.get(indexOfValue);
    }

    public void delete(String valueToInsert) {
        strings.remove(valueToInsert);
    }

    public void clear() {
        strings.clear();
    }

    @Override
    public Iterator<String> iterator() {
        return new Iterator<String>() {
            int current = 0;

            @Override
            public boolean hasNext() {
                if (current < strings.size()) {
                    return true;
                } else {
                    return false;
                }
            }

            @Override
            public String next() {
                if (!hasNext()) {
                    throw new NoSuchElementException("Ain't nothing there.");
                }
                return strings.get(current++);
            }
        };
    }
}
