package rocks.zipcode.io.quiz4.collections;

import rocks.zipcode.io.quiz4.objectorientation.Student;

import java.util.*;

/**
 * @author leon on 11/12/2018.
 */
public class ZipCodeWilmington {

    Map<Student, Double> studyMap;

    public ZipCodeWilmington(Map<Student, Double> studyMap) {
        this.studyMap = studyMap;
    }

    public ZipCodeWilmington() {
        this(new LinkedHashMap<>());
    }

    public void enroll(Student student) {
        this.studyMap.put(student, 0D);
    }

    public Boolean isEnrolled(Student student) {
        return this.studyMap.containsKey(student);
    }

    public void lecture(double numberOfHours) {
        for (Student dweeb : this.studyMap.keySet()) {
            dweeb.learn(numberOfHours);
        }
    }

    public Map<Student, Double> getStudyMap() {
        for (Student s : this.studyMap.keySet()) {
            this.studyMap.put(s, s.getTotalStudyTime());
        }
        return this.studyMap;
    }
}
