package rocks.zipcode.io.quiz4.generics;

import java.lang.reflect.Array;
import java.util.*;
import java.util.function.Consumer;

/**
 * @author leon on 18/12/2018.
 */
public class Group<T> implements GroupInterface<T>{

    List<T> list;

    public Group() {
        this.list = new ArrayList<>();
    }

    public Integer count() {
        return list.size();
    }


    @Override
    public void insert(T value) {
        list.add(value);
    }

    @Override
    public Boolean has(T value) {
        return list.contains(value);
    }

    public T fetch(int indexOfValue) {
        return list.get(indexOfValue);
    }

    @Override
    public void delete(T valueToInsert) {
        list.remove(valueToInsert);
    }

    public void clear() {
        list.clear();
    }

    @Override
    public Iterator<T> iterator() {
        return new Iterator<T>() {
            int current = 0;

            @Override
            public boolean hasNext() {
                if (current < list.size()) {
                    return true;
                } else {
                    return false;
                }
            }

            @Override
            public T next() {
                if (!hasNext()) {
                    throw new NoSuchElementException("Ain't nothing there.");
                }
                return list.get(current++);
            }
        };
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < list.size(); i++) {
            sb.append(list.get(i));
            if (i != list.size()-1) sb.append(", ");
        }
        return "[" +
                sb.toString() +
                ']';
    }

    public void sort() {
//        Collections.sort(list);
    }
}
